#include <duchamp/duchamp.hh>
#include <duchamp/DataArrays/SmartMask.hh>
#include <duchamp/DataArrays/DataArrayBase.hh>


namespace duchamp {

    SmartMask::SmartMask():
	DataArrayBase()
    {
    }

    SmartMask::SmartMask(const SmartMask& other):
	DataArrayBase(other)
    {
	this->operator=(other);
    }

    SmartMask& SmartMask::operator= (const SmartMask& other)
    {
	((DataArrayBase &) *this) = other;
	return *this;
    }
	
    SmartMask::~SmartMask()
    {
    }

    bool SmartMask::isMasked(size_t pix)
    {
	// is it enough to just say not available = masked?
	return (this->operator()(pix) != AVAILABLE);
    }

    bool SmartMask::isMasked(size_t *pix)
    {
	return (this->operator()(pixArrayToPos(pix)) != AVAILABLE);
    }

    bool SmartMask::isMasked(std::vector<size_t> pix)
    {
	return (this->operator()(pixVecToPos(pix)) != AVAILABLE);
    }


}
