#ifndef DUCHAMP_SEARCHER_H_
#define DUCHAMP_SEARCHER_H_

#include <iostream>
#include <duchamp/duchamp.hh>
#include <duchamp/DataArrays/AstroImage.hh>
#include <duchamp/Detection/detection.hh>
#include <duchamp/Finder/DuchampFinder.hh>
#include <duchamp/Utils/Statistics.hh>

namespace duchamp
{

    class Searcher
    {
    public:
	Searcher();
	Searcher(DuchampFinder& finder);
	Searcher(const Searcher& other);
	Searcher& operator= (const Searcher& other);
	virtual ~Searcher(){};

	void search(); // use search3DArray in Cubes/CubicSearch.cc
	void spatialSearch();// use search3DArraySpatial in Cubes/CubicSearch.cc
	void spectralSearch();// use search3DArraySpectral in Cubes/CubicSearch.cc

    protected:
	AstroImage<float> *itsImage;
	std::vector<Detection> *itsDetectionList; // Use Catalogue?
	Param *itsParam;
	Statistics::StatsContainer<float> *itsStats;
	
    };

}

#endif
